import pymunk

from cocos.sprite import Sprite

from bitflags import cfg
from bitflags.data import img
from bitflags.utils import dir_from_degrees


class Bullet(Sprite):
    def __init__(self, player, on_out):
        super(Bullet, self).__init__(img('bullet.png'))
        self.on_out = on_out
        self.position = player.point_to_world(cfg.BULLET_DELTA)
        self.rotation = player.rotation

        self.direction = dir_from_degrees(self.rotation)

        self.cbody = pymunk.Body(1, 1)
        self.cbody.position = self.position

        self.cshape = pymunk.Circle(self.cbody, 1.0)
        self.cshape.collision_type = cfg.COLL_BU
        self.cshape.sensor = True

    def graphics(self, dt):
        self.position = self.cbody.position

        x, y = self.position
        if x < 0 or x > cfg.W or y < 0 or y > cfg.H:
            self.on_out(self)

    def physics(self, dt):
        self.cbody.position += self.direction * dt * cfg.BULLET_SPEED
