from pymunk.vec2d import Vec2d

from bitflags import cfg


class Constraint(object):
    def __init__(self, player, segment):

        self.minx = None
        self.maxx = None
        self.miny = None
        self.maxy = None
        if abs(segment.a.y - segment.b.y) < 5.0:
            if segment.a.y > cfg.CENTER.y:
                self.maxy = segment.a.y
            else:
                self.miny = segment.a.y
        else:
            if segment.a.x > cfg.CENTER.x:
                self.maxx = segment.a.x
            else:
                self.minx = segment.a.x

        self.segment = segment

    def __hash__(self):
        return self.segment.__hash__()

    def contain(self, position):
        x, y = position
        if self.maxy is not None:
            y = min(self.maxy - cfg.PL_RADIUS, y)
        elif self.miny is not None:
            y = max(self.miny + cfg.PL_RADIUS, y)
        elif self.maxx is not None:
            x = min(self.maxx - cfg.PL_RADIUS, x)
        elif self.minx is not None:
            x = max(self.minx + cfg.PL_RADIUS, x)

        return Vec2d(x, y)
