import os

import pyglet.image
import pyglet.font


def fullname(shortname):
    return os.path.join('data', shortname)


def img(shortname):
    return pyglet.image.load(fullname(shortname))


def anim(shortname, x_steps, y_steps, time, loop=True):
    image = img(shortname)
    grid = pyglet.image.ImageGrid(image, x_steps, y_steps)
    return grid.get_animation(time, loop=loop)


def init_font(shortname, font_name):
    pyglet.font.add_file(fullname(shortname))
    pyglet.font.load(font_name)
