from pymunk.vec2d import Vec2d

from bitflags import cfg
from bitflags.room import Room, Exit


def init_rooms():
    return [
        Room(        0, {Exit.N: 1}),
        RoomBit2(    1, {Exit.S: 0, Exit.E: 2}),
        RoomGate100( 2, {Exit.E: 6, Exit.N: 3, Exit.S: 4, Exit.W: 1}),
        RoomBit4(    3, {Exit.S: 2, Exit.E: 5}),
        RoomBit5(    4, {Exit.N: 2}),
        RoomBit8(    5, {Exit.W: 3}),
        RoomBit3(    6, {Exit.W: 2, Exit.E: 7}),
        RoomGate010( 7, {Exit.W: 6, Exit.E: 8}),
        RoomEnemy1(  8, {Exit.W: 7, Exit.N: 9, Exit.E: 10}),
        RoomBit7(    9, {Exit.S: 8}),
        Room(       10, {Exit.W: 8, Exit.S: 11}),
        RoomGate011(11, {Exit.N: 10, Exit.S: 12}),
        Room(       12, {Exit.N: 11, Exit.S: 13}),
        RoomEnd(    13, {Exit.N: 12}),
    ]


class RoomEnd(Room):
    def add_custom_items(self):
        self.create_enemy(1, 0, 1, (400, 300), 145)
        self.create_enemy(1, 1, 0, (200, 120), 25)


class RoomGate011(Room):
    def add_custom_items(self):
        self.create_gates(Exit.S, 0, 1, 1)


class RoomGate010(Room):
    def add_custom_items(self):
        self.create_gates(Exit.E, 0, 1, 0)
        self.create_loot(cfg.CENTER, 6)


class RoomGate100(Room):
    def add_custom_items(self):
        self.create_gates(Exit.E, 1, 0, 0)


class RoomGate(Room):
    def add_custom_items(self):
        self.create_gates(Exit.N, 1, 0, 0)


class RoomBit2(Room):
    def add_custom_items(self):
        self.create_loot(Vec2d(cfg.HW, cfg.H * 0.75), 2)


class RoomBit7(Room):
    def add_custom_items(self):
        self.create_loot(cfg.CENTER, 7)


class RoomBit3(Room):
    def add_custom_items(self):
        self.create_loot(cfg.CENTER, 3)


class RoomBit4(Room):
    def add_custom_items(self):
        self.create_loot(Vec2d(cfg.W * 0.33, cfg.H * 0.75), 4)


class RoomBit5(Room):
    def add_custom_items(self):
        self.create_loot(Vec2d(cfg.HW, cfg.HW), 5)


class RoomBit8(Room):
    def add_custom_items(self):
        self.create_loot(Vec2d(cfg.HW, cfg.HW), 8)


class RoomEnemy1(Room):
    def add_custom_items(self):
        self.create_enemy(0, 0, 1, (400, 300), 145)
