import math

from pymunk.vec2d import Vec2d


def angle_between(cbody1, cbody2):
    p1 = cbody1.position
    p2 = cbody1.local_to_world(Vec2d(0, 100))
    p3 = cbody2.position
    return (p1 - p2).get_angle_between(p1 - p3)


def dir_from_degrees(angle_in_degrees):
    rad = math.radians(angle_in_degrees)
    x = math.sin(rad)
    y = math.cos(rad)
    return Vec2d(x, y).normalized()
