#! /usr/bin/env python
import logging

import pymunkoptions
pymunkoptions.options["debug"] = False

import cocos

from bitflags.cfg import H, W, CAPTION
from bitflags.scenes import GameScene, StartScene
from bitflags.data import init_font


def main():
    logging.basicConfig(
        format=('%(levelname)s: %(filename)s.'
                '%(funcName)s#%(lineno)d: %(message)s'),
        level=logging.WARNING
    )

    init_font('Munro.ttf', 'Munro')

    cocos.director.director.init(
        width=W,
        height=H,
        caption=CAPTION,
        resizable=False,
    )
    cocos.director.director.run(StartScene(GameScene))


if __name__ == '__main__':
    main()
